def proc call_editor(number%)
rem this calls the editor and puts the cursor at the beginning of the
rem offending line - either by using a search string, or by going to the line
rem
rem uses the global vars subwinarray$,maxqdline%,no_pop_up%,in_file$
rem modulefile$
rem v. 1.01
local a$,call_error%,offending_file_name$
  a$=strip_spaces$(subwinarray$(number%,1 to 40))  : rem string to search for
  if len(a$)>maxqdline%:a$=a$(1 to maxqdline%)	: rem no langer than max allowed for QD search
  offending_file_name$=modulefile$(number%)
  if do_existing_qd%(number%):return		: rem try to call existing qd
  a$='\f'&offending_file_name$&"\s{"&a$&"}"	: rem make cmd line for qd
  if default_input_dir$<>"":a$=a$&'\d'&default_input_dir$
  call_error%=0
  if is_thg(qd_thg$):exep qd_thg$; a$ :return	: rem call from thing and leave
  if not ftest(qd_file$) and qd_file$<>""
       ex qd_file$ ; a$ 			: rem exec qd file if found
  else
       dr_unst warn_defn			: rem neither QD thing nor file found!
       error_string$=error_message$(6)
       print_error 0				: rem so complain
       return 0
  endif
end def call_editor
:
def fn do_existing_qd% (number%)
rem this checks whether there is an existing qd editing this file,
rem and if so, calls up this qd and goes to linenumber$(number%)
rem
rem returns 1 if this was successful, 0 if not
rem
rem uses global vars modulefile$,linenumber$, hotkey$
rem
LOCal lp%,lnumber$,file_name$
  file_name$=modulefile$(number%)
  if file_name$="":return 0			: rem if no filename: oops
  if not is_job('qd '&file_name$):return 0	: rem no qd editing this file, yet
  lnumber$=linenumber$(number%)
  ert hot_wake(hotkey$,'qd '&file_name$)
  hot_do hotkey$
  ert hot_remv(hotkey$)
  wait 5					: rem wake job (if button)
  ert hot_pick(hotkey$,'qd '&file_name$)
  hot_do hotkey$
  ert hot_remv(hotkey$) 			: rem pick job (to be sure)
  wait 15
  ert hot_key(hotkey$,chr$(240))
  hot_do hotkey$				: rem f3
  ert hot_remv(hotkey$)
  wait 5
  ert hot_key(hotkey$,'g')			: rem 'g' = goto menu
  hot_do hotkey$
  ert hot_remv(hotkey$)
  wait 15
  for lp%=1 to len(lnumber$)
    ert hot_key(hotkey$,lnumber$(lp%))		: rem insert linenumbers
    hot_do hotkey$
    ert hot_remv(hotkey$)
    wait 5
  end for lp%
  ert hot_key(hotkey$,chr$(10)) 		: rem insert enter
  hot_do hotkey$
  ert hot_remv(hotkey$)
  return 1					: rem all ok!
end def do_existing_qd%
:
