def proc get_file_with_line
rem this prompts for a line number, and call QD with the file and the
rem line number
rem rem uses global var lineno$,error_message$
rem
local number,lp%,n%
  rep lp%
    number=getstr$(line_it%,1,main_defn,"")	: rem get number
    if number>0 and number<32768 and int (number)=number:exit lp% : rem got a valid nbr
    if number=0:return		: rem nothing chosen, or ESC
    number=warning_pos%(error_message$(12),0,"",20*65536+app_y%+8) : rem complain number is no good
  end rep lp%
  n%=number
  number=get_file%(n%,0)	: rem get the line and file into arrays
  if not number
    error_string$=error_message$(13)&cr$&n%
    print_error 0
  else
    call_editor 0		: rem call editor for this
  endif
end def get_file_with_line
:
def proc get_file_with_proc (event%)
rem get a file with a procedure, for editing
rem
rem uses global vars info_message$, error_message$, p_to_l$, default_output_dir$
rem v. 1.01
local lp%,chan%,fnproc$,found%,a$,temp%
  fnproc$=""
  if event%=1
    fnproc$=get_a_procedure$
  else
    fnproc$=read_string$(info_message$(3),,info_message$(4),60,,,main_coul%)
  endif
  if fnproc$="":return			: rem get name of fn/proc; leave if none
  chan%=fop_in(default_output_dir$&p_to_l$): rem try to open p to l file
  if chan%<0
    chan%=fop_in(p_to_l$)		: rem if pb, open with default dir
    if chan%<0
      error_string$=error_message$(14)&cr$&p_to_l$
      print_error 0			: rem oops, couldn't find the file
      return
    endif
  endif
  rep lp%
    if eof(#chan%):exit lp%		: rem do until found
    input#chan%,a$:input#chan%,a$	: rem empty, proc name
    temp%=" " instr a$			: rem find space
    if not temp%:exit lp%		: rem if no space here, the file is corrupted!
    a$=strip_spaces$(a$(temp%+1 to))	: rem strip space, get the proc name
    if a$==fnproc$:found%=1:exit lp%	: rem found this procedure/fn
    input#chan%,a$:input#chan%,a$	: rem lines containing line no, file
  end rep lp%
  if not found%
      error_string$=error_message$(15)&cr$&fnproc$
      print_error 0			: rem complain : proc not found
      close#chan%
      return
  endif
  input#chan%,a$			: rem this is line with line numbers
  close#chan%
  a$=a$(10 to 14)			: rem and this is the start line number
  temp%=a$
  temp%=get_file%(temp%,0)		: rem get the line and file into arrays 0
  if not temp%
    error_string$=error_message$(15)&cr$&fnproc$
    print_error 0			: rem complain if not found
  else
    call_editor 0			: rem call editor for this
  endif
end def get_file_with_proc
:
